!src "music_data.asm"

MUSIC_EOR_ON = 1
MUSIC_EOR_DELAY = 1600
MUSIC_TREMOLO_ON = 0
MUSIC_TREMOLO_DELAY = 4

;sound_num = Music_zp_base + 0
music_order_i = Music_zp_base + 1
music_ppos = Music_zp_base + 2
music_pdelay = Music_zp_base + 3
music_tmp = Music_zp_base + 4
music_set = Music_zp_base + 5
music_pptr = Music_zp_base + 6
music_pptrh = Music_zp_base + 7
music_ch1_out = Music_zp_base + 8
music_ch2_out = Music_zp_base + 9
music_ch3_out = Music_zp_base + 10
Music_zp_len0 = 11

!if MUSIC_EOR_ON > 0 {
music_ch1_eor = Music_zp_base + Music_zp_len0 + 0
music_ch2_eor = Music_zp_base + Music_zp_len0 + 1
music_ch3_eor = Music_zp_base + Music_zp_len0 + 2
music_ch1_eor_next = Music_zp_base + Music_zp_len0 + 3
music_ch2_eor_next = Music_zp_base + Music_zp_len0 + 4
music_ch3_eor_next = Music_zp_base + Music_zp_len0 + 5
music_tmpx = Music_zp_base + Music_zp_len0 + 6
music_tmpy = Music_zp_base + Music_zp_len0 + 7
Music_zp_len1 = 8
} else {
Music_zp_len1 = 0
}

!if MUSIC_TREMOLO_ON > 0 {
music_tremolo_delay = Music_zp_base + Music_zp_len0 + Music_zp_len1 + 0
music_tremolo_pos = Music_zp_base + Music_zp_len0 + Music_zp_len1 + 1
Music_zp_len2 = 2
} else {
Music_zp_len2 = 0
}

Music_var_last = Music_zp_base + Music_zp_len0 + Music_zp_len1 + Music_zp_len2 - 1

!if Music_var_last > $ff {
!warn "music zp goes to stack"
!warn Music_var_last - $100
}

; Z = 1 on exit
music_order_set:
    ldx music_order_i
    lda music_order,x
    tax
    cpx #$ff
    bne +
    inx
    stx music_order_i
+   lda music_pattern_addr_l,x
    sta music_pptr
    lda music_pattern_addr_h,x
    sta music_pptrh
    lda #0
    sta music_ppos
    rts

!if MUSIC_TREMOLO_ON > 0 {
music_tremolo_tbl:
!by  8,8,8,8,7,7,6,6,5,6,6,6,7,7,8,8
}

music_nmi_handler:
    pha
    txa
    pha
    lda $9114   ; ACK NMI timer 1
    lda $9111   ; ACK NMI restore
!if DEBUG_NMI_LEN > 0 {
    lda $900f
    pha
    lda #$1d
    sta $900f
}
    bit music_set
    bpl music_nmi_handler_exit

!if MUSIC_TREMOLO_ON > 0 {
    lda flag_music
    beq +
    dec music_tremolo_delay
    bpl +
    lda #MUSIC_TREMOLO_DELAY
    sta music_tremolo_delay

    ldx music_tremolo_pos
    lda music_tremolo_tbl,x
    sta $900e
    inx
    txa
    and #$f
    sta music_tremolo_pos
+
}

!if MUSIC_EOR_ON > 0 {
    lda music_ch1_eor
    beq +
    eor $900a
    sta $900a
+
    lda music_ch2_eor
    beq +
    eor $900b
    sta $900b
+
    lda music_ch3_eor
    beq +
    eor $900c
    sta $900c
+
}

music_nmi_handler_exit:
!if DEBUG_NMI_LEN > 0 {
    pla
    sta $900f
}
    pla
    tax
    pla
    rti

music_clear:
    lda #0
    sta music_set
    sta $900a
    sta $900b
    sta $900c
    sta $900d
    rts

music_stop:
!if (MUSIC_EOR_ON > 0) | (MUSIC_TREMOLO_ON > 0) {
    ; disable NMI
    lda #$7f
    sta $911e
}

    jsr music_clear

!if MUSIC_TREMOLO_ON > 0 {
    lda flag_music
    beq +
    lda #SOUND_VOLUME
+   sta $900e
}

!if (MUSIC_EOR_ON > 0) | (MUSIC_TREMOLO_ON > 0) {
    ; setup running counter on VIA 2
    ldx #$ff
    stx $9116
    stx $9115
}
    rts

music_init_do:
    ; NOTE: must preserve y
    jsr music_clear

    ldx #Music_var_last - Music_zp_base
-   sta Music_zp_base,x
    dex
    bpl -

    jsr music_order_set

    lda #1
    sta music_pdelay

!if (MUSIC_EOR_ON > 0) | (MUSIC_TREMOLO_ON > 0) {
    lda #<music_nmi_handler
    sta $0318
    lda #>music_nmi_handler
    sta $0319

    ; setup running counter on VIA 2
    ldx #<MUSIC_EOR_DELAY
    lda #>MUSIC_EOR_DELAY
    stx $9116
    sta $9115
    lda #$40
    sta $911b       ; enable Timer A free run on VIA 2

    lda #$c0
    sta $911e
}

    ; enable sound_fx_play
    lda #0
    sta sound_fx_play_ch
music_play_exit0:
    rts

music_play_do:
    lda music_set
    bmi +
    dec music_set
    ; music_set == 0
!if MUSIC_EOR_ON > 0 {
    lda music_ch1_eor_next
    sta music_ch1_eor
    lda music_ch2_eor_next
    sta music_ch2_eor
    lda music_ch3_eor_next
    sta music_ch3_eor
}
    lda music_ch1_out
    ldx music_ch2_out
    ldy music_ch3_out
    sta $900a
    stx $900b
    sty $900c

    dec music_set
    ; music_set == $ff

+   dec music_pdelay
    bne music_play_exit0

-   ldy music_ppos
    lda (music_pptr),y
    bne +
    ; next pattern on orderlist
    inc music_order_i
    jsr music_order_set
    beq -   ; bra
+   sta music_tmp
    and #$f
    sta music_pdelay

    iny
    ldx #0
--  rol music_tmp
    bcc +
    lda (music_pptr),y
    sta music_ch1_out,x

!if MUSIC_EOR_ON > 0 {
    ; check/setup eor
    sty music_tmpy
    stx music_tmpx

    ldy music_tmpx
    ldx music_eor_tbl_tbl,y

-   cmp music_eor_ch1_tbl,x
    beq music_got_eor
    bcs music_no_eor
    inx
    inx
    bne -   ; bra

music_no_eor:
    lda #0
    beq music_eor_done  ; bra

music_got_eor:
    inx
    lda music_eor_ch1_tbl,x

music_eor_done:
    ldx music_tmpx
    sta music_ch1_eor_next,x
    ldy music_tmpy
}

    iny
+   inx
    cpx #3
    bne --

    sty music_ppos

    lda #1
    sta music_set
    rts
