SOUND_FX_CMD_STOP = $00
SOUND_FX_CMD_CH1 = $70
SOUND_FX_CMD_CH2 = $71
SOUND_FX_CMD_CH3 = $72
SOUND_FX_CMD_CH4 = $73
SOUND_FX_CMD_JUMP = $74    ; index
SOUND_FX_CMD_FDIFF = $75    ; freq diff/frame
SOUND_FX_CMD_NOTEOFF = $7f

sound_num = Music_zp_base + 0
sound_fx_delay = Music_zp_base + 1

music_init:
    jmp sound_or_music_init
music_play:
sound_fx_play_ch = * + 1
    ldx #$ff
    bmi sound_exit

    lda sound_num
    bne sound_fx_play
    jmp music_play_do

sound_fx_play:
    dec sound_fx_delay
    bpl sound_fx_play_set

sound_fx_play_i = * + 1
    ldy #$00

sound_fx_play_loop:
    lda sound_data_fx,y
    beq sound_exit
    bmi sound_fx_play_got_note
    cmp #SOUND_FX_CMD_CH1
    bcc sound_fx_play_got_delay
    cmp #SOUND_FX_CMD_NOTEOFF
    beq sound_fx_play_got_noteoff
    cmp #SOUND_FX_CMD_JUMP
    beq sound_fx_play_got_jump
    bcc sound_fx_play_got_ch

sound_fx_play_got_fdiff:
    iny
    lda sound_data_fx,y
    sta sound_fx_play_fdiff
    iny
    bne sound_fx_play_loop ; bra

sound_fx_play_got_jump:
    iny
    lda sound_data_fx,y
    tay
    jmp sound_fx_play_loop

sound_fx_play_got_ch:
    and #3
    tax
    stx sound_fx_play_ch
    iny
    jmp sound_fx_play_loop

sound_fx_play_got_noteoff:
    lda #0
sound_fx_play_got_note:
    sta $900a,x
    iny
    bne sound_fx_play_loop ; bra

sound_fx_play_got_delay:
    sta sound_fx_delay
    iny
    sty sound_fx_play_i

sound_fx_play_set:
sound_fx_play_fdiff = * + 1
    lda #$00
    clc
    adc $900a,x
    sta $900a,x
sound_exit:
    rts

sound_or_music_init:
    sta sound_or_music_smc_a
    stx sound_or_music_smc_x
    ; disable sound_fx_play
    ldx #$ff
    stx sound_fx_play_ch
    ; init state
    sta sound_num
    cmp #0
    bne sound_fx_init_do
    jsr music_init_do
    jmp sound_or_music_exit
sound_fx_init_do:
    tax
    lda sound_fx_offs,x
    sta sound_fx_play_i
    lda #0
    sta $900a
    sta $900b
    sta $900c
    sta $900d
    sta sound_fx_play_fdiff
    lda #1
    sta sound_fx_delay
    ; enable sound_fx_play
    lda #0
    sta sound_fx_play_ch
sound_or_music_exit:
sound_or_music_smc_a = * + 1
    lda #$00
sound_or_music_smc_x = * + 1
    ldx #$00
    rts

sound_data_fx:
!by 0
sound_data_fx1:
!by SOUND_FX_CMD_CH3, $dc, SOUND_FX_CMD_FDIFF, -1, 25, SOUND_FX_CMD_FDIFF, -2, 50, SOUND_FX_CMD_FDIFF, 0, SOUND_FX_CMD_NOTEOFF ; 0 on next line
sound_data_fx0:
!by 0
sound_data_fx2:
!by SOUND_FX_CMD_CH4, $f0, 1, $e0, 1, $d0, 1, SOUND_FX_CMD_NOTEOFF, 0
sound_data_fx3:
!by SOUND_FX_CMD_CH4, $92, 1, $a2, 1, $9f, 1, SOUND_FX_CMD_NOTEOFF, 0
sound_data_fx4:
!by SOUND_FX_CMD_CH4, $ff, 1, SOUND_FX_CMD_NOTEOFF, SOUND_FX_CMD_CH3, $e0, 1, SOUND_FX_CMD_NOTEOFF, 0
sound_data_fx5:
!by SOUND_FX_CMD_CH4, $ff, 1, SOUND_FX_CMD_NOTEOFF, SOUND_FX_CMD_CH3, $a0, 1, SOUND_FX_CMD_NOTEOFF, 0
sound_data_fx6:
!by SOUND_FX_CMD_CH3, $d1, 5, SOUND_FX_CMD_NOTEOFF, 5, SOUND_FX_CMD_JUMP, sound_data_fx6 - sound_data_fx + 1

!if * - sound_data_fx > $100 {
!error "sound fx data too long"
!error * - sound_data_fx - $100
}

sound_fx_offs:
!by sound_data_fx0 - sound_data_fx
!by sound_data_fx1 - sound_data_fx
!by sound_data_fx2 - sound_data_fx
!by sound_data_fx3 - sound_data_fx
!by sound_data_fx4 - sound_data_fx
!by sound_data_fx5 - sound_data_fx
!by sound_data_fx6 - sound_data_fx
